

#include "BUILTIN.h"

#include "Nat.h"
extern TUP2 _ASeqMapEnv_4(OBJ,OBJ,OBJ);extern OBJ __ASeqMapEnv_4;
extern OBJ _ASetConv_3(OBJ,OBJ);extern OBJ __ASetConv_3;

#include "Char.h"
extern TUP2 _ASetMapEnv_6(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __ASetMapEnv_6; /* * */

extern TUP2 _ASetMapEnv_6(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* * */
{TUP2 r;
 FRCLS(x1,1);
 {TUP2 x8;
  x8=_ASeqMapEnv_4(x3,x4,x5);r.c1=x8.c1;
  r.c2=_ASetConv_3(x2,x8.c2);}
 return r;}
extern OBJ _ASetMapEnv_6_c(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* * */
{OBJ r;
 {TUP2 t=_ASetMapEnv_6(x1,x2,x3,x4,x5);
  PRD1(2,r);
  FLD1(r,1)=t.c1;
  FLD1(r,2)=t.c2;}
 return r;}

static OBJ _mt_5_0_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,2);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 return r;}

static OBJ _mt_5_2_3(OBJ t,OBJ t1,OBJ t2,OBJ t3) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),t1,t2,t3);
 return r;}

init_ASetMapEnv()
{
 static int visited=0; if(visited) return; visited=1;
 init_ASet();
 init_ANat();
 init_ASeq();
 init_AOption();
 init_ASeqMapEnv();
 init_ASetConv();
 init_AString();
 init_AChar();
 init_ASeqConv();
 CLS(5,_ASetMapEnv_6_c,__ASetMapEnv_6);
 MTH(5,0,2,_mt_5_0_2);LZYMTH(5,0,2,_mt_5_0_2);
 MTH(5,2,3,_mt_5_2_3);LZYMTH(5,2,3,_mt_5_2_3);}

